<?php

require __DIR__ . '/vendor/autoload.php';


//当前时间
// 设置时区为中国标准时间（北京时间）


$reactConnector = new \React\Socket\Connector([
    'dns' => '8.8.8.8',
    'timeout' => 10
]);
$loop = \React\EventLoop\Loop::get();
$connector = new \Ratchet\Client\Connector($loop, $reactConnector);
$NetInSpeed = 0;
$NetOutSpeed = 0;
$connector('ws://8.218.114.138:8008/ws', [], ['Origin' => 'http://8.218.114.138:8008'])
    ->then(function(\Ratchet\Client\WebSocket $conn) use (&$NetInSpeed, &$NetOutSpeed) {
        $conn->on('message', function(\Ratchet\RFC6455\Messaging\MessageInterface $msg) use ($conn, &$NetInSpeed, &$NetOutSpeed) {

            $servers = json_decode($msg)->servers;
            //找到"ID": 3的数据
            $server = array_filter($servers, function($server) {
                return $server->ID == 3;
            });

            $NetInSpeed = $server[2]->State->NetInSpeed;
            $NetOutSpeed = $server[2]->State->NetOutSpeed;
            //转换成MB
            $NetInSpeed = $NetInSpeed / 1024 / 1024;
            $NetOutSpeed = $NetOutSpeed / 1024 / 1024;
            if ($NetInSpeed > 5 || $NetOutSpeed > 5){
                echo "查询到带宽为6M，开始执行限速\n";
                //获取access_token
                $url = 'http://47.120.27.113/RR1gcxXn/v1/login';
                $data = array(
                    'username' => 'admin001',
                    'password' => 'admin001',
                    'customfield' => array(
                        'google_code' => ''
                    )
                );

                $headers = array(
                    'accept: application/json, text/plain, */*',
                    'accept-language: en-US,en;q=0.9,zh-CN;q=0.8,zh;q=0.7,en-GB;q=0.6',
                    'cache-control: no-cache',
                    'content-security-policy: upgrade-insecure-requests',
                    'content-type: application/json;charset=UTF-8',
                    'think-lang: zh-cn'
                );

                $ch = curl_init($url);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                curl_setopt($ch, CURLOPT_REFERER, 'http://47.120.27.113/RR1gcxXn/');
                curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
                curl_setopt($ch, CURLOPT_POST, true);
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); // 不验证证书
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false); // 不验证主机名
                curl_setopt($ch, CURLOPT_HEADER, false); // 不返回头部信息
                curl_setopt($ch, CURLOPT_NOBODY, false); // 返回正文

                $response = curl_exec($ch);
                if (curl_errno($ch)) {
                    echo 'Error: ' . curl_error($ch);
                }
                curl_close($ch);
                //去掉开头和末尾的引号
                $access_token =  substr($response, 1, -1);

                $url = 'http://47.120.27.113/RR1gcxXn/v1/clouds?page=1&per_page=50&search=&sort=desc&orderby=current_in_bw&searchtype=0&image_version=&advanced_cpu=&advanced_bw=';

                $headers = array(
                    'accept: application/json, text/plain, */*',
                    'accept-language: en-US,en;q=0.9,zh-CN;q=0.8,zh;q=0.7,en-GB;q=0.6',
                    'access-token: ' . $access_token,
                    'cache-control: no-cache',
                    'pragma: no-cache',
                    'think-lang: en-us'
                );

                $ch = curl_init($url);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                curl_setopt($ch, CURLOPT_REFERER, 'http://47.120.27.113/RR1gcxXn/');
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); // 不验证证书
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false); // 不验证主机名
                curl_setopt($ch, CURLOPT_HEADER, false); // 不返回头部信息
                curl_setopt($ch, CURLOPT_NOBODY, false); // 返回正文

                $response = curl_exec($ch);
                if (curl_errno($ch)) {
                    echo 'Error: ' . curl_error($ch);
                }
                curl_close($ch);

                $response = json_decode($response);
                //获取前5个服务器
                $servers = $response->data;
                $servers = array_slice($servers, 0, 5);
                foreach ($servers as $server) {
                    
                    
                    
                    $my_in_bw = (int)($server->in_bw);
                    $my_out_bw = $server->out_bw;
                    
                    // 去掉单位符号bps并转换为整数
                    $before_in_bw_bps = (int)str_replace("bps", "", $server->current_in_bw);
                    $before_out_bw_bps = (int)str_replace("bps", "", $server->current_out_bw);
                    
                    if($before_in_bw_bps>20){
                                            // 将bps转换为MBps
                 //   echo $before_in_bw_bps ."单位是b";
                    $before_in_bw = $before_in_bw_bps / 1024*8; // 1 MBps = 8,000,000 bps
                    $before_out_bw = $before_out_bw_bps / 1024*8;
                    
                    }else{
                                                                    // 将bps转换为MBps
               //     echo $before_in_bw_bps ."本身就是m";
                    $before_in_bw = $before_in_bw_bps; // 1 MBps = 8,000,000 bps
                    $before_out_bw = $before_out_bw_bps;
                    };
                    
                    
                    
                    

                    $in_bw = $before_in_bw;
                    $out_bw = $before_out_bw;
                    $url = 'http://47.120.27.113/RR1gcxXn/v1/bws/' . $server->id;
                    $need_limit = 0;
                    if ($in_bw > 1) {
                      $in_bw = ceil($in_bw / 2); // 将 in_bw 大于 1 的值改为一半，使用 ceil() 函数确保结果为整数
                      //  $in_bw = ceil(1); // 将 in_bw 大于 1 的值改为一半，使用 ceil() 函数确保结果为整数
                        $need_limit = 1;
                    }
                    if ($out_bw > 1) {
                         $in_bw = ceil($in_bw / 2); // 将 in_bw 大于 1 的值改为一半，使用 ceil() 函数确保结果为整数
                      //  $in_bw = ceil(1); // 将 in_bw 大于 1 的值改为一半，使用 ceil() 函数确保结果为整数
                         $need_limit = 1;
                    }
                    
                    

                    if ($need_limit == 1) {
                             date_default_timezone_set('Asia/Shanghai'); 
                          // 获取当前时间戳
                    $current_time = time();
                    // 使用 date 函数格式化时间，并输出
                    $time = date('Y-m-d H:i:s', $current_time);
                            echo $time;
                        //实例ip：103.112.96.20 当前带宽为： 2Mbps，需要进行限速处理
                        echo "实例ip: " . $server->mainip . " 当前带宽为： " .$before_in_bw . "Mbps，需要进行限速处理\n";
                        $data = array(
                            'id' => 192,
                            'in_bw' => $in_bw,
                            'out_bw' => $out_bw,
                        );

                        $headers = array(
                            'accept: application/json, text/plain, */*',
                            'accept-language: en-US,en;q=0.9,zh-CN;q=0.8,zh;q=0.7,en-GB;q=0.6',
                            'access-token: ' . $access_token,
                            'cache-control: no-cache',
                            'content-type: application/json;charset=UTF-8',
                            'pragma: no-cache',
                            'think-lang: zh-cn',
                            'referrer: http://47.120.27.113/RR1gcxXn/'
                        );

                        $ch = curl_init($url);
                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
                        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
                        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

                        $response = curl_exec($ch);
                        if (curl_errno($ch)) {
                            echo 'Error:' . curl_error($ch);
                        }else{
                            
                            
                            
                                     $current_time = time();
// 使用 date 函数格式化时间，并输出
$time = date('Y-m-d H:i:s', $current_time);
       // echo $time."\n";
                            $record_time=$time;
                            
                            #将修改前的带宽值保存到数据库中 插入
                            $servername = "8.218.114.138";
                            $username = "idc";
                            $password = "d844F7AiMF8KPxPC";
                            $dbname = "idc";
                            $mysqlconn = new mysqli($servername, $username, $password, $dbname);
                            if ($mysqlconn->connect_error) {
                                die("连接失败: " . $mysqlconn->connect_error);
                            }
$sql = "INSERT INTO `bw_limit` (`id`, `ip`, `before_in_bw`, `before_out_bw`, `in_bw`, `out_bw`, `record_time`)
        VALUES (?, ?, ?, ?, ?, ?, ?)
        ON DUPLICATE KEY UPDATE `in_bw`=VALUES(`in_bw`), `out_bw`=VALUES(`out_bw`), `record_time`= ?";

                            echo "设置的带宽".$my_in_bw;
                            
                    $stmt = $mysqlconn->prepare($sql);
$stmt->bind_param("ssssssss", $server->id, $server->mainip, $my_in_bw, $my_out_bw, $in_bw, $out_bw, $record_time, $record_time);

if (!$stmt->execute()) {
    echo "Error executing statement: " . $stmt->error;
}
$stmt->close();




                      $servername = "8.218.114.138";
    $username = "idc";
    $password = "d844F7AiMF8KPxPC";
    $dbname = "idc";
    $mysqlconn = new mysqli($servername, $username, $password, $dbname);
    if ($mysqlconn->connect_error) {
        die("连接失败: " . $mysqlconn->connect_error);
    }
    
    
    // 构建 SQL 查询
    // 准备更新语句
$sql = "UPDATE bw_limit SET cisu=cisu+1  WHERE ip = '" . $server->mainip . "'";

    
   // $sql = "SELECT * FROM `bw_limit` WHERE record_time < DATE_SUB(NOW(), INTERVAL ".$mm." minute)";
  //  echo  $sql;
    $result = $mysqlconn->query($sql);
    $mysqlconn->close();







                            
                            $chan_bw=$in_bw*2;
                            
                            
                            
                                                         date_default_timezone_set('Asia/Shanghai'); 
                            // 获取当前时间戳
                            $current_time = time();
                            // 使用 date 函数格式化时间，并输出
                            $time = date('Y-m-d H:i:s', $current_time);
                                  //  echo $time."\n";
                            
                            
                            
                            //实例ip：103.112.96.20 实时带宽为2Mbps，已经对其限速为1mbps
                            echo "实例ip: " . $server->mainip . " 实时带宽为" . $before_in_bw . "Mbps，已经对其限速为" . $in_bw . "mbps\n";
                        }
                        curl_close($ch);
                    }
                    else{
                        
                        
                                                     date_default_timezone_set('Asia/Shanghai'); 
      // 获取当前时间戳
$current_time = time();
// 使用 date 函数格式化时间，并输出
$time = date('Y-m-d H:i:s', $current_time);
     //   echo $time."\n";
                        
                        
                        
                      echo "实例ip: " . $server->mainip . " 实时带宽为" . $before_in_bw . "Mbps，不需要限速\n";
                    }
                }


            }

        });

        $conn->on('close', function($code = null, $reason = null) {
            echo "Connection closed ({$code} - {$reason})\n";
        });

    }, function(\Exception $e) use ($loop) {
        echo "Could not connect: {$e->getMessage()}\n";
        $loop->stop();
    });



$loop->addPeriodicTimer(5, function() use ($loop) {
    
    // 假设你已经设置好数据库连接

    $servername = "8.218.114.138";
    $username = "idc";
    $password = "d844F7AiMF8KPxPC";
    $dbname = "idc";

// 创建连接
$conn = new mysqli($servername, $username, $password, $dbname);

// 检查连接
if ($conn->connect_error) {
  die("连接失败: " . $conn->connect_error);
}

// 构建查询语句
$sql = "SELECT limit1, time FROM type WHERE id = 1";

// 执行查询
$result = $conn->query($sql);

// 检查查询结果
if ($result->num_rows > 0) {
  // 输出数据
  while($row = $result->fetch_assoc()) {
  //  echo "limit1: " . $row["limit1"]. " - time: " . $row["time"]. "<br>";
    
    $limit1= $row["limit1"];
$rowtime= $row["time"];
    
  }
} else {
  echo "未找到符合条件的记录";
}


// 关闭连接
$conn->close();




//$tt=$rowtime;
//$mm=formatTime($seconds);


$tt=$rowtime;
$mm= floor($rowtime / 60);
echo $mm ."...";
    

    $servername = "8.218.114.138";
    $username = "idc";
    $password = "d844F7AiMF8KPxPC";
    $dbname = "idc";
    $mysqlconn = new mysqli($servername, $username, $password, $dbname);
    if ($mysqlconn->connect_error) {
        die("连接失败: " . $mysqlconn->connect_error);
    }
    
    
        // 定义变量
    $interval = $mm; // 6分钟作为变量

    // 构建 SQL 查询
/*    $sql = "SELECT * FROM `bw_limit` WHERE record_time < DATE_SUB(NOW(), INTERVAL $interval MINUTE) and record_time>0";*/
$sql = "SELECT * FROM `bw_limit` 
        WHERE record_time < DATE_SUB(NOW(), INTERVAL $interval MINUTE) 
          AND record_time > 0
        ORDER BY record_time ASC";
    
   // $sql = "SELECT * FROM `bw_limit` WHERE record_time < DATE_SUB(NOW(), INTERVAL ".$mm." minute)";
  //  echo  $sql;
    $result = $mysqlconn->query($sql);
    $mysqlconn->close();
    if ($result->num_rows > 0) {

     
        
        while ($row = $result->fetch_assoc()) {
            //*/******************************************************************************************************
            $iid=   $row['id'];
         $iip  = $row['ip'];
       $iin_bw   =  $row['in_bw'];
         //*/******************************************************************************************************
            //获取access_token
            $url = 'http://47.120.27.113/RR1gcxXn/v1/login';
            $data = array(
                'username' => 'admin001',
                'password' => 'admin001',
                'customfield' => array(
                    'google_code' => ''
                )
            );

            $headers = array(
                'accept: application/json, text/plain, */*',
                'accept-language: en-US,en;q=0.9,zh-CN;q=0.8,zh;q=0.7,en-GB;q=0.6',
                'cache-control: no-cache',
                'content-security-policy: upgrade-insecure-requests',
                'content-type: application/json;charset=UTF-8',
                'think-lang: zh-cn'
            );

            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            curl_setopt($ch, CURLOPT_REFERER, 'http://47.120.27.113/RR1gcxXn/');
            curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); // 不验证证书
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false); // 不验证主机名
            curl_setopt($ch, CURLOPT_HEADER, false); // 不返回头部信息
            curl_setopt($ch, CURLOPT_NOBODY, false); // 返回正文

            $response = curl_exec($ch);
            if (curl_errno($ch)) {
                echo 'Error: ' . curl_error($ch);
            }
            curl_close($ch);
            
            
            
        //现有带宽向上加1即可
        
            
            
            if($row['before_in_bw']-$row['in_bw']>=1){
                
   $inw=$row['in_bw']+1;
        
            }else{
                $inw=$row['before_in_bw'];
                      $servername = "8.218.114.138";
    $username = "idc";
    $password = "d844F7AiMF8KPxPC";
    $dbname = "idc";
    $mysqlconn = new mysqli($servername, $username, $password, $dbname);
    if ($mysqlconn->connect_error) {
        die("连接失败: " . $mysqlconn->connect_error);
    }
    
    
    // 构建 SQL 查询
    // 准备更新语句
$sql = "UPDATE bw_limit SET record_time='0'  WHERE id = '" . $row['id'] . "'";

    
   // $sql = "SELECT * FROM `bw_limit` WHERE record_time < DATE_SUB(NOW(), INTERVAL ".$mm." minute)";
  //  echo  $sql;
    $result = $mysqlconn->query($sql);
    $mysqlconn->close();
            };
            
             echo "实例{$iip} 设置带宽为{$row['before_in_bw']}Mbps，已经对其限速为{$row['in_bw']}Mbps，现在已经解除限制为{$inw}Mbps\n";

            //去掉开头和末尾的引号
            $access_token =  substr($response, 1, -1);
            $url = 'http://47.120.27.113/RR1gcxXn/v1/bws/' . $row['id'];
            $data = array(
                'in_bw' => $inw,
                'out_bw' => $inw,
            );
    

	$servername = "8.218.114.138";
    $username = "idc";
    $password = "d844F7AiMF8KPxPC";
    $dbname = "idc";
    $mysqlconn = new mysqli($servername, $username, $password, $dbname);
    if ($mysqlconn->connect_error) {
        die("连接失败: " . $mysqlconn->connect_error);
    }
    $current_time = time();
// 使用 date 函数格式化时间，并输出
$time = date('Y-m-d H:i:s', $current_time);
      //  echo $time."\n";
    
    // 构建 SQL 查询
    // 准备更新语句
//$sql = "UPDATE bw_limit SET in_bw = '" . $inw . "' ,record_time='" . $time . "'  WHERE id = '" . $row['id'] . "'";

 $sql = "SELECT cisu FROM bw_limit WHERE  id = '" . $row['id'] . "'";
   // $sql = "SELECT * FROM `bw_limit` WHERE record_time < DATE_SUB(NOW(), INTERVAL ".$mm." minute)";
  //  echo  $sql;
    $result = $mysqlconn->query($sql);
           // 检查查询是否成功
if ($result === false) {
    echo "查询失败: " . $mysqlconn->error;
} else {
    // 检查是否有结果行
    if ($result->num_rows > 0) {
        // 输出获取到的 cishu 字段的值
        $row = $result->fetch_assoc(); // 获取查询结果的关联数组形式
       // echo "cisu 字段的值为: " . $row['cisu']."\n";
        $life=$row['cisu'];
    } else {
        echo "未找到匹配的记录。\n";
    }
}

// 释放查询结果
$result->free();

// 关闭数据库连接
$mysqlconn->close();
            
            
            
      
            
            if($life<80){
                
            
                
               // $inw=$row['in_bw']+1;
                      $servername = "8.218.114.138";
    $username = "idc";
    $password = "d844F7AiMF8KPxPC";
    $dbname = "idc";
    $mysqlconn = new mysqli($servername, $username, $password, $dbname);
    if ($mysqlconn->connect_error) {
        die("连接失败: " . $mysqlconn->connect_error);
    }
    $current_time = time();
// 使用 date 函数格式化时间，并输出
$time = date('Y-m-d H:i:s', $current_time);
      //  echo $time."\n";
    
    // 构建 SQL 查询
    // 准备更新语句
$sql = "UPDATE bw_limit SET in_bw = '" . $inw . "' ,record_time='" . $time . "'  WHERE id = '" . $iid . "'";

    
   // $sql = "SELECT * FROM `bw_limit` WHERE record_time < DATE_SUB(NOW(), INTERVAL ".$mm." minute)";
  //  echo  $sql;
    $result = $mysqlconn->query($sql);
    $mysqlconn->close();
                
                  //   $row['before_in_bw']
           //  $row['before_out_bw']
            
            $headers = array(
                'accept: application/json, text/plain, */*',
                'accept-language: en-US,en;q=0.9,zh-CN;q=0.8,zh;q=0.7,en-GB;q=0.6',
                'access-token: ' . $access_token,
                'cache-control: no-cache',
                'content-type: application/json;charset=UTF-8',
                'pragma: no-cache',
                'think-lang: zh-cn',
                'referrer: http://47.120.27.113/RR1gcxXn/'
            );
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
            curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

            $response = curl_exec($ch);
            if (curl_errno($ch)) {
                echo 'Error:' . curl_error($ch);
            };
            
  /*  $servername = "8.218.114.138";
    $username = "idc";
    $password = "d844F7AiMF8KPxPC";
    $dbname = "idc";
            
            $mysqlconn = new mysqli($servername, $username, $password, $dbname);
            $mysqlconn->query("DELETE FROM `bw_limit` WHERE `id` = '{$row['id']}'");
            $mysqlconn->close();
            curl_close($ch);*/
                                         date_default_timezone_set('Asia/Shanghai'); 
                  // 获取当前时间戳
            $current_time = time();
            // 使用 date 函数格式化时间，并输出
            $time = date('Y-m-d H:i:s', $current_time);
                  //  echo $time."\n";
            //实例ip：103.112.96.20 实时带宽为2Mbps，已经对其限速为1mbps，现在已经解除限制为5m
  
            }else{
                
                echo "太多次了，解封次数用完了\n";
echo $iid;
//echo 
     
     $servername = "8.218.114.138";
$username = "idc";
$password = "d844F7AiMF8KPxPC";
$dbname = "idc";

// 创建连接
$mysqli = new mysqli($servername, $username, $password, $dbname);

// 检查连接是否成功
if ($mysqli->connect_error) {
    die("连接失败: " . $mysqli->connect_error);
};

// 要更新的记录的 id 和时间
//$row_id = $row['id'];  // 假设 $row['id'] 是你要更新的特定记录的ID
//$time = date('Y-m-d H:i:s');  // 当前时间，格式为 'Y-m-d H:i:s'
$current_time = date('Y-m-d H:i:s');  // 获取当前时间，格式为 'Y-m-d H:i:s'

// 将当前时间字符串转换为时间戳，然后增加10秒
$time = date('Y-m-d H:i:s', strtotime($current_time) + 10);
// 构建 SQL 更新语句
$sql = "UPDATE bw_limit SET record_time = '$time'  WHERE id = '" . $iid . "'";
//echo $sql;
// 执行更新操作
if ($mysqli->query($sql) === TRUE) {
    echo "记录更新成功";
} else {
    echo "更新记录时出现错误: " . $mysqli->error;
}

// 关闭数据库连接
$mysqli->close();
 sleep(1);
                break;
            };
            

                    
            sleep(1);
                break;

        }
    }

});




