<?php

// IP地址
$ip = '103.112.96.168';

// 无限循环，每秒执行一次
while (true) {
    // 执行ping命令并获取延迟时间
    // 使用 -c 1 参数表示只 ping 一次，-W 1 表示超时时间为1秒
    exec("ping -c 1 -W 1 $ip", $output, $result);

    // 解析ping结果
    if ($result == 0) {
        // 提取延迟时间，这里假设延迟时间在第二行第四个单词（如：time=23.5ms）
        if (preg_match('/time=([0-9\.]+) ms/', $output[1], $matches)) {
            $delay = $matches[1];
            echo "延迟时间：$delay 毫秒\n";
        } else {
            echo "无法解析延迟时间\n";
        }
    } else {
        echo "Ping失败\n";
    }

    // 等待一秒钟
    sleep(1);
}

?>